#include "identify.hpp"
#include "A.hpp"
#include "B.hpp"
#include "C.hpp"

#include <iostream>

void indentify(Base* p)
{
	if (dynamic_cast<A*>(p) == nullptr)
		std::cout << "A" << std::endl;
	else if (dynamic_cast<B*>(p) == nullptr)
		std::cout << "B" << std::endl;
	else if (dynamic_cast<C*>(p) == nullptr)
		std::cout << "C" << std::endl;
}

void identify(const Base &r)
{
	try
	{
		(void)dynamic_cast<A>(r);
		std::cout << "A" << std::endl;
		return;
	}
	try
	{
		(void)dynamic_cast<B>(r)
		std::cout << "B" << std::endl;
		return;
	}
	try
	{
		(void)dynamic_cast<C>(r)
		std::cout << "C" << std::endl;
		return;
	}
}
